Attribute VB_Name = "Declaraciones"
Public T As Double
Public S As Double
Public c_X(22) As Double
Public c_Y(22) As Double
Public abat(528) As Double
Public cPunto As cRedG
Public colPunto As colRed

Public Sub resolver()
Dim suma As Double
Dim i As Integer, punto, pozo, r, u, w, a
frmResultados.MSFlexGrid1.Clear
frmResultados.MSFlexGrid1.Cols = 2
frmResultados.MSFlexGrid1.Rows = 2
frmResultados.MSFlexGrid1.FormatString = "^ No. |^ Punto "
frmResultados.MSFlexGrid1.Cols = frmNoPozos.MSFlexGrid1.Rows

For i = 1 To frmNoPozos.MSFlexGrid1.Rows - 2
    frmResultados.MSFlexGrid1.FormatString = frmResultados.MSFlexGrid1.FormatString & "|^   Pozo " & frmNoPozos.MSFlexGrid1.TextMatrix(i, 1) & "[m]   "
Next i

For punto = 1 To frmCoordAbat.MSFlexGrid1.Rows - 2
    frmResultados.MSFlexGrid1.Rows = frmResultados.MSFlexGrid1.Rows + 1
    frmResultados.MSFlexGrid1.TextMatrix(punto, 0) = punto
    frmResultados.MSFlexGrid1.TextMatrix(punto, 1) = frmCoordAbat.MSFlexGrid1.TextMatrix(punto, 1)
    For pozo = 1 To frmNoPozos.MSFlexGrid1.Rows - 2
        r = Sqr((Val(frmCoordAbat.MSFlexGrid1.TextMatrix(punto, 2)) - Val(frmNoPozos.MSFlexGrid1.TextMatrix(pozo, 4))) ^ 2 + (Val(frmCoordAbat.MSFlexGrid1.TextMatrix(punto, 3)) - Val(frmNoPozos.MSFlexGrid1.TextMatrix(pozo, 5))) ^ 2)
        If r = 0 Then
            r = Val(frmNoPozos.MSFlexGrid1.TextMatrix(pozo, 2)) / 2
        End If
        u = r * r * S / (4 * T * Val(frmCoordAbat.txtTiempo) * 86400)
        w = -0.577216 - Log(u) + u - u * u / 4 + u * u * u / 18 - u ^ 4 / 96 + u ^ 5 / 600
        a = frmNoPozos.MSFlexGrid1.TextMatrix(pozo, 3) * w / (4 * 3.14159265358979 * T)
        frmResultados.MSFlexGrid1.TextMatrix(punto, pozo + 1) = Format(a, "##.####")
    Next pozo
Next punto

frmResultados.MSFlexGrid1.Cols = frmResultados.MSFlexGrid1.Cols + 1
frmResultados.MSFlexGrid1.FormatString = frmResultados.MSFlexGrid1.FormatString & "|^ Abatimiento Total[m] "
For n = 1 To frmResultados.MSFlexGrid1.Rows - 2
    suma = 0
    For j = 2 To frmResultados.MSFlexGrid1.Cols - 2
        suma = suma + Val(frmResultados.MSFlexGrid1.TextMatrix(n, j))
    Next j
    frmResultados.MSFlexGrid1.TextMatrix(n, frmResultados.MSFlexGrid1.Cols - 1) = suma
Next n

graficar

End Sub

Public Sub graficar()
Dim g As New Excel.Application
Dim ch As ChartObject
Dim x_min As Double
Dim x_max As Double
Dim y_min As Double
Dim y_max As Double
Dim i As Integer
Dim j As Integer
Dim z As Integer


g.Workbooks.Add
g.ActiveSheet.Range("B1") = "Pozos"
For p = 1 To frmNoPozos.MSFlexGrid1.Rows - 2
    g.ActiveSheet.Range("A" & p + 1) = frmNoPozos.MSFlexGrid1.TextMatrix(p, 4)
    g.ActiveSheet.Range("B" & p + 1) = frmNoPozos.MSFlexGrid1.TextMatrix(p, 5)
Next p
g.ActiveSheet.Range("D1") = "Puntos"
For pto = 1 To frmCoordAbat.MSFlexGrid1.Rows - 2
        g.ActiveSheet.Range("C" & pto + 1) = frmCoordAbat.MSFlexGrid1.TextMatrix(pto, 2)
        g.ActiveSheet.Range("D" & pto + 1) = frmCoordAbat.MSFlexGrid1.TextMatrix(pto, 3)
Next pto


Set ch = g.Worksheets(1).ChartObjects.Add(100, 30, 500, 360)
ch.Chart.ChartWizard Source:=g.ActiveSheet.Range("A1:B" & (frmNoPozos.MSFlexGrid1.Rows)), _
    gallery:=xlXYScatter, Format:=1, SeriesLabels:=1

ch.Chart.ChartArea.Interior.Pattern = xlPatternSolid
ch.Chart.ChartArea.Interior.Color = vbWhite
ch.Chart.PlotBy = xlColumns
ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("D1:D" & frmCoordAbat.MSFlexGrid1.Rows), SeriesLabels:=True
ch.Chart.SeriesCollection(2).XValues = g.ActiveSheet.Range("C2:C" & frmCoordAbat.MSFlexGrid1.Rows)
ch.Chart.PlotArea.Interior.Color = vbWhite


'INICIA CALCULO DE RED DE ABATIMIENTO

y_max = ch.Chart.Axes(xlValue, xlPrimary).MaximumScale
y_min = ch.Chart.Axes(xlValue, xlPrimary).MinimumScale
x_max = ch.Chart.Axes(xlCategory, xlPrimary).MaximumScale
x_min = ch.Chart.Axes(xlCategory, xlPrimary).MinimumScale

Intervalos x_min, x_max, y_min, y_max

g.ActiveSheet.Range("F1") = "Abat. <= 10.0 m"
g.ActiveSheet.Range("H1") = "10.0 < Abat. <= 20.0 m"
g.ActiveSheet.Range("J1") = "20.0 < Abat. <= 30.0 m"
g.ActiveSheet.Range("L1") = "30.0 < Abat. <= 40.0 m"
g.ActiveSheet.Range("N1") = "40.0 < Abat. <= 50.0 m"
g.ActiveSheet.Range("P1") = "50.0 < Abat. <= 60.0 m"
g.ActiveSheet.Range("R1") = "Abat. >= 60.0 m"
i = 2
j = 2
k = 2
l = 2
m = 2
n = 2
o = 2
For Each cPunto In colPunto
    If cPunto.abat <= 10# Then
        g.ActiveSheet.Range("E" & i) = cPunto.x
        g.ActiveSheet.Range("F" & i) = cPunto.y
        i = i + 1
    ElseIf cPunto.abat > 10# And cPunto.abat <= 20# Then
        g.ActiveSheet.Range("G" & j) = cPunto.x
        g.ActiveSheet.Range("H" & j) = cPunto.y
        j = j + 1
    ElseIf cPunto.abat > 20# And cPunto.abat <= 30# Then
        g.ActiveSheet.Range("I" & k) = cPunto.x
        g.ActiveSheet.Range("J" & k) = cPunto.y
        k = k + 1
    ElseIf cPunto.abat > 30# And cPunto.abat <= 40# Then
        g.ActiveSheet.Range("K" & l) = cPunto.x
        g.ActiveSheet.Range("L" & l) = cPunto.y
        l = l + 1
    ElseIf cPunto.abat > 40# And cPunto.abat <= 50# Then
        g.ActiveSheet.Range("M" & m) = cPunto.x
        g.ActiveSheet.Range("N" & m) = cPunto.y
        m = m + 1
    ElseIf cPunto.abat > 50# And cPunto.abat <= 60# Then
        g.ActiveSheet.Range("O" & n) = cPunto.x
        g.ActiveSheet.Range("P" & n) = cPunto.y
        n = n + 1
    ElseIf cPunto.abat > 60# Then
        g.ActiveSheet.Range("Q" & o) = cPunto.x
        g.ActiveSheet.Range("R" & o) = cPunto.y
        o = o + 1
    End If
Next

z = 3
If g.ActiveSheet.Range("E2").Value <> "" Then
    ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("F1:F" & i), SeriesLabels:=True
    ch.Chart.SeriesCollection(z).XValues = g.ActiveSheet.Range("E1:E" & i)
    z = z + 1
End If
If g.ActiveSheet.Range("G2").Value <> "" Then
    ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("H1:H" & j), SeriesLabels:=True
    ch.Chart.SeriesCollection(z).XValues = g.ActiveSheet.Range("G1:G" & j)
    z = z + 1
End If
If g.ActiveSheet.Range("I2").Value <> "" Then
    ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("J1:J" & k), SeriesLabels:=True
    ch.Chart.SeriesCollection(z).XValues = g.ActiveSheet.Range("I1:I" & k)
    z = z + 1
End If
If g.ActiveSheet.Range("K2").Value <> "" Then
    ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("L1:L" & l), SeriesLabels:=True
    ch.Chart.SeriesCollection(z).XValues = g.ActiveSheet.Range("K1:K" & l)
    z = z + 1
End If
If g.ActiveSheet.Range("M2").Value <> "" Then
    ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("N1:N" & m), SeriesLabels:=True
    ch.Chart.SeriesCollection(z).XValues = g.ActiveSheet.Range("M1:M" & m)
    z = z + 1
End If
If g.ActiveSheet.Range("O2").Value <> "" Then
    ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("P1:P" & n), SeriesLabels:=True
    ch.Chart.SeriesCollection(z).XValues = g.ActiveSheet.Range("O1:O" & n)
    z = z + 1
End If
If g.ActiveSheet.Range("Q2").Value <> "" Then
    ch.Chart.SeriesCollection.Add Source:=g.ActiveSheet.Range("R1:R" & o), SeriesLabels:=True
    ch.Chart.SeriesCollection(z).XValues = g.ActiveSheet.Range("Q1:Q" & o)
    z = z + 1
End If


'TERMINA RED DE ABATIMIENTO

ch.Chart.Export App.Path & "\grafico.gif", "gif"
frmResultados.Image1.Picture = LoadPicture(App.Path & "\grafico.gif")
ch.Delete
g.DisplayAlerts = False
g.Quit
Set g = Nothing
Set ch = Nothing
End Sub


Public Sub Intervalos(ByRef xMin As Double, ByRef xMax As Double, ByRef yMin As Double, ByRef yMax As Double)
Dim dx As Double
Dim dy As Double
Dim intX As Double
Dim intY As Double
intX = Abs(xMin - xMax)
dx = intX / 20
intY = Abs(yMin - yMax)
dy = intY / 20
For i = 0 To 22
    c_X(i) = (xMin - dx) + i * dx
    c_Y(i) = (yMin - dy) + i * dy
Next i
Set colPunto = New colRed
For i = 0 To 22
    For j = 0 To 22
        Set cPunto = New cRedG
        cPunto.abat = abatimiento(c_X(i), c_Y(j))
        cPunto.x = c_X(i)
        cPunto.y = c_Y(j)
        colPunto.Add cPunto.x, cPunto.y, cPunto.abat
        Set cPunto = Nothing
    Next j
Next i

End Sub

Public Function abatimiento(coorX As Double, coorY As Double) As Double
Dim aA As Double
Dim rA As Double
Dim uA As Double
Dim wA As Double
Dim x_pozoA As Double
Dim y_pozoA As Double
aA = 0
For i = 1 To frmNoPozos.MSFlexGrid1.Rows - 2
    x_pozoA = Val(frmNoPozos.MSFlexGrid1.TextMatrix(i, 4))
    y_pozoA = Val(frmNoPozos.MSFlexGrid1.TextMatrix(i, 5))
    rA = Sqr((coorX - x_pozoA) ^ 2 + (coorY - y_pozoA) ^ 2)
    If rA = 0 Then
        rA = Val(frmNoPozos.MSFlexGrid1.TextMatrix(i, 2)) / 2
    End If
    uA = rA * rA * S / (4 * T * Val(frmCoordAbat.txtTiempo) * 86400)
    wA = -0.577216 - Log(uA) + uA - uA * uA / 4 + uA * uA * uA / 18 - uA ^ 4 / 96 + uA ^ 5 / 600
    aA = aA + frmNoPozos.MSFlexGrid1.TextMatrix(i, 3) * wA / (4 * 3.14159265358979 * T)
Next i
abatimiento = aA
End Function
